
; FASM SOURCE FILE
; http://flatassembler.net

; XviD (DivX) <BI>trate <C>alculator
; some useful functions

; written by @L.CHEMIST (Andrey A. Meshkov)
; maalchemist@gmail.com
; maa-mail@yandex.ru

BICU:

; ------------------------------------------------------------------------------

; add string table to ComboBox items
;
; -> esi - string table
; -> cb1 - ComboBox (1) handle
; -> cb2 - ComboBox (2) handle
$proc fst2cb, cb1, cb2

        movzx   ebx, byte [esi]                 ; ebx = item count
        inc     esi
        movzx   edi, byte [esi]                 ; edi = item size
        add     esi, 3                          ; esi = current item name offset
    .add.string:
        invoke  SendMessage, [cb1], CB_ADDSTRING, 0, esi
        invoke  SendMessage, [cb2], CB_ADDSTRING, 0, esi
        add     esi, edi
        dec     ebx
        jnz    .add.string
        ret
$endp

; ------------------------------------------------------------------------------

; convert window text to 64-bit float
;
; -> eax - window handle
; -> edi - float value
; -> esi - buffer
$sproc wt2f64

        invoke  GetWindowText, eax, esi, 64
        cinvoke atof, esi
        fstp    qword [edi]
        retn
$endp

; ------------------------------------------------------------------------------

; convert float from st0 register to window text & pop fpu stack
;
; ->  al - precision ('0', '1', ... '9')
; -> edi - window handle
; -> esi - buffer
$sproc st2wt

        sub     esp, 8
        fstp    qword [esp]
        mov     byte [sffmt.0f + 2], al
        cinvoke vsprintf, esi, sffmt.0f, esp
;       cinvoke sprintf, esi, sffmt.0f, dword [esp], dword [esp + 4]
;       mov     byte [esi + eax], 0
        invoke  SetWindowText, edi, esi
        add     esp, 8
        retn
$endp

; ------------------------------------------------------------------------------

; convert float from st0 register to window text & pop fpu stack
;
; ->  al - precision ('0', '1', ... '9')
; -> edi - window handle
; -> esi - buffer
$sproc st2wt.KB

        sub     esp, 8
        fstp    qword [esp]
        mov     byte [sffmt.KB + 2], al
        cinvoke vsprintf, esi, sffmt.KB, esp
        invoke  SetWindowText, edi, esi
        add     esp, 8
        retn
$endp

; ------------------------------------------------------------------------------
