
; FASM SOURCE FILE
; http://flatassembler.net

; XviD(DivX) <BI>trate <C>alculator
; BIC macros

; written by @L.CHEMIST (Andrey A. Meshkov)
; maalchemist@gmail.com
; maa-mail@yandex.ru

; ------------------------------------------------------------------------------

macro fpu.init
{
        fninit
        sub     esp, 2
;       mov     word [esp], 0xF0FF ; 24-bit precision
        mov     word [esp], 0xF2FF ; 53-bit precision
;       mov     word [esp], 0xF3FF ; 64-bit precision
        fldcw   [esp]
        add     esp, 2
}

; ------------------------------------------------------------------------------

; convert float from st0 register to window text & pop fpu stack
;
; ->  al - precision = '0'
; -> edi - window handle
; -> esi - buffer
macro st2wt0 hwnd
{
        mov     al, '0'
        mov     edi, hwnd
        call    st2wt
}

; ------------------------------------------------------------------------------

; convert float from st0 register to window text & pop fpu stack
;
; ->  al - precision = '3'
; -> edi - window handle
; -> esi - buffer
macro st2wt3 hwnd
{
        mov     al, '3'
        mov     edi, hwnd
        call    st2wt
}

; ------------------------------------------------------------------------------
